package fr.jelora.minitel.enums;

public enum CodeSpecifique {
	CSI(new byte[] { 0x1B, 0x5B }),
	ESC(new byte[] { 0x1B }),
	SO(new byte[] { 0x0E }),
	SI(new byte[] { 0x0F }),
	Con(new byte[] { 0x11 }),
	Coff(new byte[] { 0x14 }),
	Sep(new byte[] { 0x13 }),
	PRO2(new byte[] { 0x1B, 0x3A }),
	MIXTE1(new byte[] { 0X32, 0X7D }),
	MIXTE2(new byte[] { 0X32, 0X7E }),
	START(new byte[] { 0x69 }),
	STOP(new byte[] { 0x6A }),
	ROULEAU(new byte[] { 0x43 }),
	SS2(new byte[] { 0x19 }),
	US(new byte[] { 0x1F });

	private final byte[] byteArrayCode;
	
	private CodeSpecifique(byte[] byteArrayCode){
		this.byteArrayCode = byteArrayCode;
	}
	
	public String toString(){
		return new String(byteArrayCode);
	}
	
	public byte[] toByteArray(){
		return byteArrayCode;
	}
	
	public byte toByte(){
		return byteArrayCode[0];
	}
}
