package fr.jelora.minitel.services.demo;

import fr.jelora.minitel.MinitelTools;
import fr.jelora.minitel.enums.ModeEcran;
import fr.jelora.minitel.exception.ReceptionException;
import fr.jelora.minitel.exception.TransmissionException;
import fr.jelora.minitel.services.ServiceMinitel;
import fr.jelora.minitel.services.ServiceMinitelAbstract;

public class ServiceDemo extends ServiceMinitelAbstract implements ServiceMinitel {
	
	private MinitelTools minitelTools;
	
	public String run(MinitelTools minitelTools) throws TransmissionException, ReceptionException {
		this.minitelTools = minitelTools;
		
		minitelTools.changerModeEcran(ModeEcran.colonnes40);
		
		minitelTools.clearAll();
		minitelTools.write("Démo utilisée lors de la vidéo Teaser");
		
		try {
			Thread.sleep(1500);
			
			affichageAnnuaire();
			
			Thread.sleep(7000);
			
			minitelTools.setCursorBlinking(false);
			for ( int i = 0 ; i<40 ; i++ ){
            	minitelTools.faireUnBip();
            	Thread.sleep(100);
            }
			
			affichageParasite();
            
            Thread.sleep(6000);
            
            affichageJeSuisDeRetour();
            
            Thread.sleep(6000);
		} 
		catch (InterruptedException e) {
			throw new TransmissionException(e);
		}
		
		
		return null;
	}
	
	private void affichageAnnuaire() throws TransmissionException {
		minitelTools.write(String.valueOf("\f").getBytes());
		
		minitelTools.write(String.valueOf((char) 0x0E).getBytes());
        
        minitelTools.write(String.valueOf((char) 0x60).getBytes());
        minitelTools.write(String.valueOf((char) 0x26).getBytes());
        minitelTools.write(String.valueOf((char) 0x23).getBytes());
        minitelTools.write(String.valueOf((char) 0x23).getBytes());
        minitelTools.write(String.valueOf((char) 0x6D).getBytes());
        minitelTools.write(String.valueOf((char) 0x30).getBytes());
        minitelTools.write(String.valueOf("\n\r").getBytes());
        minitelTools.write(String.valueOf((char) 0x31).getBytes());
        minitelTools.write(String.valueOf((char) 0x20).getBytes());
        minitelTools.write(String.valueOf((char) 0x38).getBytes());
        minitelTools.write(String.valueOf((char) 0x38).getBytes());
        minitelTools.write(String.valueOf((char) 0x38).getBytes());
        minitelTools.write(String.valueOf((char) 0x38).getBytes());
        minitelTools.write(String.valueOf("\n\r").getBytes());
        minitelTools.write(String.valueOf((char) 0x60).getBytes());
        minitelTools.write(String.valueOf((char) 0x66).getBytes());
        minitelTools.write(String.valueOf((char) 0x66).getBytes());
        minitelTools.write(String.valueOf((char) 0x66).getBytes());
        minitelTools.write(String.valueOf((char) 0x26).getBytes());
        minitelTools.write(String.valueOf((char) 0x60).getBytes());
        minitelTools.write(String.valueOf("\n\r").getBytes());
        minitelTools.write(String.valueOf((char) 0x61).getBytes());
        minitelTools.write(String.valueOf((char) 0x31).getBytes());
        minitelTools.write(String.valueOf((char) 0x21).getBytes());
        minitelTools.write(String.valueOf((char) 0x21).getBytes());
        minitelTools.write(String.valueOf((char) 0x20).getBytes());
        minitelTools.write(String.valueOf((char) 0x38).getBytes());
        minitelTools.write(String.valueOf("\n\r").getBytes());
        minitelTools.write(String.valueOf((char) 0x20).getBytes());
        minitelTools.write(String.valueOf((char) 0x2B).getBytes());
        minitelTools.write(String.valueOf((char) 0x2C).getBytes());
        minitelTools.write(String.valueOf((char) 0x2C).getBytes());
        minitelTools.write(String.valueOf((char) 0x26).getBytes());
        
        minitelTools.write(String.valueOf((char) 0x0F).getBytes());
		
		minitelTools.locate(15, 1);
		minitelTools.writeRepeteByte((byte) 127, 15);
		minitelTools.writeRepeteByte((byte) 127, 9);
		minitelTools.locate(15, 2);
		minitelTools.writeRepeteByte((byte) 127, 15);
		minitelTools.writeRepeteByte((byte) 127, 9);
		minitelTools.locate(15, 3);
		minitelTools.writeRepeteByte((byte) 127, 15);
		minitelTools.writeRepeteByte((byte) 127, 9);
		minitelTools.locate(15, 4);
		minitelTools.writeRepeteByte((byte) 127, 15);
		minitelTools.writeRepeteByte((byte) 127, 9);
		
		minitelTools.locate(11, 6);
		minitelTools.write(String.valueOf("NOM:").getBytes());
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 9);
		minitelTools.locate(11, 7);
		minitelTools.write(String.valueOf("ou  ").getBytes());
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 8);
		minitelTools.locate(6, 8);
		minitelTools.write(String.valueOf("RUBRIQUE:").getBytes());
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 9);
		minitelTools.locate(15, 9);
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 9);
		minitelTools.locate(15, 10);
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 8);
		
		minitelTools.locate(6, 11);
		minitelTools.write(String.valueOf("LOCALITE:").getBytes());
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 9);
		
		minitelTools.locate(15, 12);
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 8);
		
		minitelTools.locate(11, 13);
		minitelTools.write(String.valueOf("    vous pouvez preciser").getBytes());
		minitelTools.locate(3, 14);
		minitelTools.write(String.valueOf("DEPARTEMENT:").getBytes());
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 8);
		minitelTools.locate(7, 15);
		minitelTools.write(String.valueOf("ADRESSE:").getBytes());
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 8);
		minitelTools.locate(8, 16);
		minitelTools.write(String.valueOf("PRENOM:").getBytes());
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 8);
		
		minitelTools.locate(1, 17);
		minitelTools.writeRepeteByte((byte)'_', 15);
		minitelTools.writeRepeteByte((byte)'_', 15);
		minitelTools.writeRepeteByte((byte)'_', 7);
		
		minitelTools.locate(17, 19);
		minitelTools.write(String.valueOf("ligne suivante ").getBytes());
		minitelTools.writeRepeteByte((byte) 127, 8);
		minitelTools.locate(15, 20);
		minitelTools.write(String.valueOf("ligne precedente ").getBytes());
		minitelTools.writeRepeteByte((byte) 127, 8);
		minitelTools.locate(24, 21);
		minitelTools.write(String.valueOf("effacer ").getBytes());
		minitelTools.writeRepeteByte((byte) 127, 8);
		minitelTools.locate(10, 22);
		minitelTools.write(String.valueOf("choisir dans la liste ").getBytes());
		minitelTools.writeRepeteByte((byte) 127, 8);
		minitelTools.locate(13, 23);
		minitelTools.write(String.valueOf("obtenir la reponse ").getBytes());
		minitelTools.writeRepeteByte((byte) 127, 8);
		
		minitelTools.locate(15, 6);
		minitelTools.write(String.valueOf((char) 17).getBytes());
	}
	
	private void affichageParasite() throws TransmissionException {
		minitelTools.write(String.valueOf("\f").getBytes());
		
		//minitelTools.locate(1, 1);
		minitelTools.writeRepeteByte((byte) 127, 15);
		
		minitelTools.locate(15, 20);
		minitelTools.writeRepeteByte((byte) 127, 15);
		minitelTools.writeRepeteByte((byte) 127, 15);
		
		minitelTools.locate(20, 24);
		minitelTools.writeRepeteByte((byte) 127, 15);
		
		minitelTools.locate(35, 12);
		minitelTools.writeRepeteByte((byte) 127, 15);
		
		minitelTools.locate(25, 5);
		minitelTools.write(String.valueOf("KJLHSF QMDKLHMQHIOPH ZIF /§QSDF A0834 PQOFJ20 03R 3RU 3U2R POJ A FPO%JA£Z9°PR2R").getBytes());
		
		minitelTools.locate(3, 10);
		minitelTools.writeRepeteByte((byte)'.', 5);
		
		minitelTools.locate(3, 10);
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 15);
		minitelTools.writeRepeteByte((byte)'.', 15);
		
		minitelTools.locate(1, 20);
		minitelTools.write(String.valueOf("qhmlk HDFMGSDFM JKSMDHGFMO jhsjkdgh JOHKLOHF 153 4GS35D4F 352135FSDG4UHd PMUMOQSHIJF ").getBytes());
		
		minitelTools.locate(13, 2);
		minitelTools.write(String.valueOf('F').getBytes());
		minitelTools.locate(13, 3);
		minitelTools.write(String.valueOf('R').getBytes());
		minitelTools.locate(13, 4);
		minitelTools.write(String.valueOf('A').getBytes());
		minitelTools.locate(13, 5);
		minitelTools.write(String.valueOf('N').getBytes());
		minitelTools.locate(13, 6);
		minitelTools.write(String.valueOf('C').getBytes());
		minitelTools.locate(13, 7);
		minitelTools.write(String.valueOf('E').getBytes());
		minitelTools.locate(15, 9);
		minitelTools.write(String.valueOf('T').getBytes());
		minitelTools.locate(15, 10);
		minitelTools.write(String.valueOf('E').getBytes());
		minitelTools.locate(15, 11);
		minitelTools.write(String.valueOf('L').getBytes());
		minitelTools.locate(17, 12);
		minitelTools.write(String.valueOf('E').getBytes());
		minitelTools.locate(17, 13);
		minitelTools.write(String.valueOf('C').getBytes());
		minitelTools.locate(17, 14);
		minitelTools.write(String.valueOf('O').getBytes());
		minitelTools.locate(19, 15);
		minitelTools.write(String.valueOf('M').getBytes());
		
		
		
		minitelTools.locate(30, 2);
		minitelTools.write(String.valueOf("Meteo").getBytes());
		
		minitelTools.locate(2, 17);
		minitelTools.write(String.valueOf("Annuaire").getBytes());
		
		minitelTools.locate(7, 4);
		minitelTools.write(String.valueOf("Resultats du BAC").getBytes());
		
		minitelTools.locate(22, 30);
		minitelTools.write(String.valueOf("3 6 1 5").getBytes());
		
		minitelTools.locate(33, 1);
		minitelTools.write(String.valueOf("0,35F/mn").getBytes());
		
	}
	
	private void affichageJeSuisDeRetour() throws TransmissionException{
		minitelTools.write(String.valueOf("\f").getBytes());
		
		minitelTools.locate(13, 8);
        minitelTools.write(String.valueOf("Je suis de retour").getBytes());
        
        try {
			Thread.sleep(1500);
		} 
        catch (InterruptedException e) {
			throw new TransmissionException(e);
		}
        
        minitelTools.locate(15, 13);
        minitelTools.write(String.valueOf("CONNEXION FIN").getBytes());
        
        char c = 17;
        minitelTools.write(String.valueOf(c).getBytes());
	}

}
